/*
  This code was written by Raymond Chi-Wing Wong.
  Please read the following.

    Raymond Chi-Wing Wong, Yufei Tao, Ada Wai-Chee Fu and Xiaokui Xiao. 
    "On Efficient Spatial Matching", 
    the 33rd International Conference on Very Large Data Bases (VLDB'07), 
    Vienna, Austria on 23-28 Sept, 2007 

*/

#include "set.h"

mySet *mySet_new()
{
	mySet *returnValue;

	returnValue = (mySet *) malloc(sizeof(mySet));
	memset(returnValue, 0, sizeof(mySet));

	return returnValue;
}

void mySet_free(mySet **aSet)
{
	int noOfElt;

	noOfElt = (*aSet)->noOfElt;
	if (noOfElt > 0)
	{
		free((*aSet)->elt);
	}
	free((*aSet));
}

void mySet_insert(mySet *aSet, int aElt)
{
	int noOfElt;
	int *elt;

	noOfElt = aSet->noOfElt;
	elt = aSet->elt;

	if (noOfElt == 0)
	{
		elt = (int *) malloc(sizeof(int));
	}
	else
	{
		elt = (int *) realloc(elt, sizeof(int)*(noOfElt+1));
	}
	elt[noOfElt] = aElt;

	aSet->noOfElt++;
	aSet->elt = elt;
}

